<?php
namespace App\Http\Controllers\Owner;

use App\Http\Controllers\Controller;

use DB;
use Illuminate\Http\Request;
use Illuminate\Support\Str;

use App\Http\Helpers\ResponseBuilder;
use App\Http\Helpers\ParamsValidator;
use Intervention\Image\ImageManagerStatic as Image;

class c_Notification extends Controller
{
    private $oDomain;

    public function __construct()
    {
        $this->oDomain = "Notification";
    }

    public function Insert_All(Request $Request){
        $oResponse  = array();
        $oValParams = array(    'Notification_Type'     => 'required|int',
                                'Notification'          => 'required|string',
                            );


        // VALIDANDO DATOS
        $oResponse = ParamsValidator::Validate_Request($Request,$oValParams,$this->oDomain);
        
        //  INGRESANDO DATOS
        if ($oResponse["Response_Code"] == 200) {
            
            $Notification = json_decode($Request->input("Notification"));

            for($i = 0; $i < count($Notification); $i++){
                
                $oParam = array(    $Notification[$i]->Notification_Description,
                                    $Request->input("Notification_Type"),
                                    $Notification[$i]->Id,
                                    $Request->header("Token"),
                                    1
                                );
                $oData = DB::select('call sp_notification_insert(?,?,?,?,?)',$oParam);
            }

            //  RESPONSE
            if($oData[0]->Response_Success == 1){
                
            }else{
                
            }
            
            $oResponse["Response_Status"]           = $oData[0]->Response_Status;
            $oResponse["Response_Code"]             = $oData[0]->Response_Code;
            $oResponse["Response_Domain"]           = $this->oDomain;
            $oResponse["Response_Message"]          = $oData[0]->Response_Message;
            $oResponse["Response_Data"]             = null;
            $oResponse["Response_Error_Message"]    = $oData[0]->Response_Message;
            $oResponse["Response_Error_Reason"]     = $oData[0]->Response_Reason;
        }

        return ResponseBuilder::Response($oResponse);
        
    }
    public function Insert(Request $Request){
        $oResponse  = array();
        $oValParams = array(    'Notification_Description'  => 'required|string',
                                'Notification_Type'         => 'required|int',
                                'Id'                        => 'required|int'
                            );


        // VALIDANDO DATOS
        $oResponse = ParamsValidator::Validate_Request($Request,$oValParams,$this->oDomain);
        
        //  INGRESANDO DATOS
        if ($oResponse["Response_Code"] == 200) {           
            $oParam = array(    $Request->input("Notification_Description"),
                                $Request->input("Notification_Type"),
                                $Request->input("Id"),
                                $Request->header("Token"),
                                1
                            );
            $oData = DB::select('call sp_notification_insert(?,?,?,?,?)',$oParam);

            //  RESPONSE
            if($oData[0]->Response_Success == 1){
                
            }else{
                
            }
            
            $oResponse["Response_Status"]           = $oData[0]->Response_Status;
            $oResponse["Response_Code"]             = $oData[0]->Response_Code;
            $oResponse["Response_Domain"]           = $this->oDomain;
            $oResponse["Response_Message"]          = $oData[0]->Response_Message;
            $oResponse["Response_Data"]             = null;
            $oResponse["Response_Error_Message"]    = $oData[0]->Response_Message;
            $oResponse["Response_Error_Reason"]     = $oData[0]->Response_Reason;
        }

        return ResponseBuilder::Response($oResponse);
        
    }
    public function Accept(Request $Request){
        $oResponse  = array();
        $oValParams = array( 'Id_Notification'  => 'required|int' );


        // VALIDANDO DATOS
        $oResponse = ParamsValidator::Validate_Request($Request,$oValParams,$this->oDomain);
        
        //  INGRESANDO DATOS
        if ($oResponse["Response_Code"] == 200) {           
            $oParam = array(    $Request->input("Id_Notification"),
                                $Request->header("Token")
                            );
            $oData = DB::select('call sp_notification_accept(?,?)',$oParam);

            //  RESPONSE
            if($oData[0]->Response_Success == 1){
                
            }else{
                
            }
            
            $oResponse["Response_Status"]           = $oData[0]->Response_Status;
            $oResponse["Response_Code"]             = $oData[0]->Response_Code;
            $oResponse["Response_Domain"]           = $this->oDomain;
            $oResponse["Response_Message"]          = $oData[0]->Response_Message;
            $oResponse["Response_Data"]             = null;
            $oResponse["Response_Error_Message"]    = $oData[0]->Response_Message;
            $oResponse["Response_Error_Reason"]     = $oData[0]->Response_Reason;
        }

        return ResponseBuilder::Response($oResponse);

    }
    public function Delete(Request $Request, $Id){
        $oResponse  = array();

        // VALIDANDO DATOS
        $oResponse = ParamsValidator::Validate_Id($Id,$this->oDomain);
        
        //  INGRESANDO DATOS
        if ($oResponse["Response_Code"] == 200) {           
            $oParam = array(    $Id,
                                $Request->header("Token") 
                            );
            $oData  = DB::select('call sp_notification_delete(?,?)',$oParam);

            //  RESPONSE
            if($oData[0]->Response_Success == 1){
                
            } else {
                
            }
            
            $oResponse["Response_Status"]           = $oData[0]->Response_Status;
            $oResponse["Response_Code"]             = $oData[0]->Response_Code;
            $oResponse["Response_Domain"]           = $this->oDomain;
            $oResponse["Response_Message"]          = $oData[0]->Response_Message;
            $oResponse["Response_Data"]             = null;
            $oResponse["Response_Error_Message"]    = $oData[0]->Response_Message;
            $oResponse["Response_Error_Reason"]     = $oData[0]->Response_Reason;
        }

        return ResponseBuilder::Response($oResponse);
    }
    public function Index(Request $Request, $Id){
        $oResponse  = array();

        // VALIDANDO DATOS
        $oResponse = ParamsValidator::Validate_Id($Id,$this->oDomain);
        
        //  INGRESANDO DATOS
        if ($oResponse["Response_Code"] == 200) {       
            $oParam = array( $Id );
            $oData  = DB::select('call sp_notification_index(?)',$oParam);
            
            $oResponse["Response_Status"]           = 200;
            $oResponse["Response_Code"]             = 200;
            $oResponse["Response_Domain"]           = $this->oDomain;
            $oResponse["Response_Message"]          = $this->oDomain." Index";
            $oResponse["Response_Data"]             = $oData;
            $oResponse["Response_Error_Message"]    = "";
            $oResponse["Response_Error_Reason"]     = "";
        }

        return ResponseBuilder::Response($oResponse);
    }
    public function List(Request $Request){
        $oResponse  = array();
        $oValParams = array(    'Notification_Type' => 'required|int',
                                'Id'                => 'required|int'
                            );


        // VALIDANDO DATOS
        $oResponse = ParamsValidator::Validate_Request($Request,$oValParams,$this->oDomain);
        
        //  INGRESANDO DATOS
        if ($oResponse["Response_Code"] == 200) {   
            $oParam = array(    $Request->input("Notification_Type"),
                                $Request->input("Id")
                            );
            $oData  = DB::select('call sp_notification_list(?,?)',$oParam);

            $oResponse["Response_Status"]           = 200;
            $oResponse["Response_Code"]             = 200;
            $oResponse["Response_Domain"]           = $this->oDomain;
            $oResponse["Response_Message"]          = $this->oDomain." list";
            $oResponse["Response_Data"]             = $oData;
            $oResponse["Response_Error_Message"]    = "";
            $oResponse["Response_Error_Reason"]     = "";
        }

        return ResponseBuilder::Response($oResponse);
    }

    public function Report(Request $Request){
        $oResponse  = array();
        $oValParams = array(    'PermissionBookingTourPassenger'    => 'required|int',
                                'PermissionGroupPassenger'          => 'required|int',
                                'PermissionGroupProvider'           => 'required|int',
                                'PermissionGroup'                   => 'required|int'
                            );


        // VALIDANDO DATOS
        $oResponse = ParamsValidator::Validate_Request($Request,$oValParams,$this->oDomain);
        
        //  INGRESANDO DATOS
        if ($oResponse["Response_Code"] == 200) {   
            $oParam = [
                $Request->input("PermissionBookingTourPassenger"),
                $Request->input("PermissionGroupPassenger"),
                $Request->input("PermissionGroupProvider"),
                $Request->input("PermissionGroup"),
            ];
            $oData  = DB::select('call sp_notification_report(?,?,?,?)', $oParam);

            $oResponse["Response_Status"]           = 200;
            $oResponse["Response_Code"]             = 200;
            $oResponse["Response_Domain"]           = $this->oDomain;
            $oResponse["Response_Message"]          = $this->oDomain." list";
            $oResponse["Response_Data"]             = $oData;
            $oResponse["Response_Error_Message"]    = "";
            $oResponse["Response_Error_Reason"]     = "";
        }

        return ResponseBuilder::Response($oResponse);
    }

        
        
}