<?php

/** @var \Laravel\Lumen\Routing\Router $router */

use App\Modules\LeadBookingPackage\Domain\LeadBookingPackageRepository;
use App\Modules\LeadBookingPackage\Infrastructure\MysqlLeadBookingPackageRepository;

$router->post(
    '/leadBookingPackage',
    [
        'middleware' => 'Auth_Owner',
        'uses' => 'LeadBookingPackage\\LeadBookingPackageInsertController@__invoke'
    ]
);


$app->bind(LeadBookingPackageRepository::class, fn($app) => $app->make(MysqlLeadBookingPackageRepository::class));
